//+------------------------------------------------------------------+
//|                                                    SimpleGrid.mq4+ 
//+------------------------------------------------------------------+


#include <stdlib.mqh>
#include <WinUser32.mqh>
#property strict

// exported variables
extern string GridStartingPrice = " Start Price to Place Lines ";
extern double GSP = 0.0;
extern int GR = 5; 
extern double GridStep = 5;
extern color  CGL = Gold;
extern color  BGL = Green;
extern color  SGL = Red; 
extern bool ClearAllObjects = False;



// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;
 
 


int init()

{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
    return(0);
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
   
    OnEveryTick7();
    return (0);
       
}

void OnEveryTick7()
{
    PipValue = 1;
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
     CentreGridLine();  
        
  
}
   

void CentreGridLine()
{     if (ObjectFind("CGL") == (-1) )
{
  {  
      string objName = "CGL"  ;
    ObjectCreate(objName, OBJ_HLINE, 0, Time[0],GSP);
    ObjectSet(objName, OBJPROP_PRICE1, GSP);
    ObjectSet(objName, OBJPROP_COLOR,CGL);  
       
    
  }
  TradeLine();
   UprBnd();
   LwrBnd();
}


}
void TradeLine()
  {
   int i;
   double GridStep1= (GridStep*2);
   double BGSP= (GSP+((GridStep/2)*PipValue*Point)) ;
   double SGSP= (GSP-((GridStep/2)*PipValue*Point));
   double BBGSP= (BGSP-((GridStep*(GR))*PipValue*Point)) ;
   double SSGSP= (SGSP+((GridStep*(GR))*PipValue*Point));  
    
   {
   for(i=0; i<GR;i++)
    {
    SGL("Sell"+i,BBGSP+GridStep1*i*PipValue*Point);
    }
   }
 
   {
   for(i=0; i<GR;i++)
    {
    BGL("Buy"+i,SSGSP-GridStep1*i*PipValue*Point);
    }
   }
   
  }
  
  
 void BGL(string objName, double price)
   {  
   
   ObjectCreate(objName, OBJ_HLINE, 0, 0, price);
   ObjectSet(objName, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(objName, OBJPROP_WIDTH, 1);
   ObjectSet(objName, OBJPROP_COLOR, BGL);
   }
   
 void SGL(string objName, double price)
   {  
   
   ObjectCreate(objName, OBJ_HLINE, 0, 0, price);
   ObjectSet(objName, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(objName, OBJPROP_WIDTH, 1);
   ObjectSet(objName, OBJPROP_COLOR, SGL);
   }   
   
   
void UprBnd()
{ if (ObjectFind("UPRBND") == (-1) )
{
    double BGSP= (GSP+((GridStep/2)*PipValue*Point)) ;
    double price= (BGSP+((GridStep*(GR))*PipValue*Point)) ;
    string objName = "UPRBND"  ;
    ObjectCreate(objName, OBJ_HLINE, 0, Time[0], price );
    ObjectSet(objName, OBJPROP_PRICE1,price);
    ObjectSet(objName, OBJPROP_COLOR, DodgerBlue);    
    ObjectSet(objName, OBJPROP_WIDTH,3);
}
    
}


void LwrBnd()
{ if (ObjectFind("LWRBND") == (-1) )
{
    double SGSP= (GSP-((GridStep/2)*PipValue*Point));
    double price= (SGSP-((GridStep*(GR))*PipValue*Point));
    string objName = "LWRBND"  ;
    ObjectCreate(objName, OBJ_HLINE, 0, Time[0], price );
    ObjectSet(objName, OBJPROP_PRICE1,price);
    ObjectSet(objName, OBJPROP_COLOR, Tomato);    
    ObjectSet(objName, OBJPROP_WIDTH, 3);
}
 
}
 
int deinit()
{
  if (ClearAllObjects) ObjectsDeleteAll();
    
    return (0);
    
}


//+------------------------------------------------------------------+ 
  
